#include <gtk/gtk.h>

static void print_hello (GtkWidget *widget,
             gpointer   data)
{
  /*print in a terminal*/
  g_print ("Clicked\n");
}

static void
activate (GtkApplication *app,
          gpointer        user_data)
{
  GtkWidget *window;
  GtkWidget *button;

  /*controlling button size and layout by storing it inside a box*/
  GtkWidget *button_box;

  window = gtk_application_window_new (app);
  gtk_window_set_title (GTK_WINDOW (window), "Title");
  gtk_window_set_default_size (GTK_WINDOW (window), 200, 200);

  /*create and assigen box with orientation*/
  button_box = gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);

  /*add button box to window*/
  gtk_container_add (GTK_CONTAINER (window), button_box);

  /*initialise button*/
  button = gtk_button_new_with_label ("Button");

  /*connect button with callback function with NULL as input*/
  g_signal_connect (button, "clicked", G_CALLBACK (print_hello), NULL);

  /*connect button with destroy callback to destroy the window instead of the button*/
  g_signal_connect_swapped (button, "clicked", G_CALLBACK (gtk_widget_destroy), window);

  /*add button to window*/
  gtk_container_add (GTK_CONTAINER (button_box), button);

  gtk_widget_show_all (window);
}

int
main (int    argc,
      char **argv)
{
  GtkApplication *app;
  int status;

  app = gtk_application_new ("org.gtk.example", G_APPLICATION_FLAGS_NONE);
  g_signal_connect (app, "activate", G_CALLBACK (activate), NULL);
  status = g_application_run (G_APPLICATION (app), argc, argv);
  g_object_unref (app);

  return status;
}
